import 'package:equatable/equatable.dart';
import 'package:flutter/foundation.dart';

import '../core.dart';

class ServerException extends Equatable implements Exception {
  final ExceptionCode code;
  final String message;

  const ServerException({@required this.code, @required this.message});

  @override
  List<Object> get props => [code, message];

  @override
  String toString() {
    return '[ServerException] code: ${code.toString()}, message:$message';
  }
}

class CacheException extends Equatable implements Exception {
  final ExceptionCode code;
  final String message;

  const CacheException({@required this.code, @required this.message});

  @override
  List<Object> get props => [code, message];

  @override
  String toString() {
    return '[CacheException] code: ${code.toString()}, message:$message';
  }
}

class AuthException extends Equatable implements Exception {
  final ExceptionCode code;
  final String message;

  const AuthException({@required this.code, @required this.message});

  @override
  List<Object> get props => [code, message];

  @override
  String toString() {
    return '[AuthException] code: ${code.toString()}, message:$message';
  }
}
