import 'package:equatable/equatable.dart';
import 'package:flutter/foundation.dart';

import '../core.dart';

abstract class Failure extends Equatable {
  const Failure();

  @override
  List<Object> get props => [];
}

class ServerFailure extends Failure {
  final ExceptionCode code;
  final String message;

  const ServerFailure({@required this.code, @required this.message});

  @override
  List<Object> get props => [code, message];

  @override
  String toString() {
    return '[ServerException] code: ${code.toString()}, message:$message';
  }
}

class AuthFailure extends Failure {
  final ExceptionCode code;
  final String message;

  const AuthFailure({@required this.code, @required this.message});

  @override
  List<Object> get props => [code, message];

  @override
  String toString() {
    return '[AuthFailure] code: ${code.toString()}, message:$message';
  }
}
