import 'package:uuid_type/uuid_type.dart';

class UniqueId {
  final Uuid value;

  factory UniqueId() {
    return UniqueId._(Uuid(uuid.v4()));
  }

  factory UniqueId.fromUniqueString(String uniqueId) {
    assert(uniqueId != null, 'uniqueId cannot be null');
    return UniqueId._(Uuid(uniqueId));
  }

  factory UniqueId.fromJson(Map<String, dynamic> json) {
    assert(json != null && json.isNotEmpty, 'UniqueId.fromJson cannot be null or empty');
    return UniqueId._(Uuid(json['id']));
  }

  const UniqueId._(this.value);

  @override
  bool operator ==(Object o) {
    if (identical(this, o)) return true;

    return o is UniqueId && o.value == value;
  }

  @override
  int get hashCode => value.hashCode;

  @override
  String toString() => 'UniqueId(value: ${value.toString()})';
}
