import 'package:equatable/equatable.dart';
import 'package:flutter/cupertino.dart';

import '../../core/core.dart';
import '../../models/models.dart';

class M4eAuthOTPVerificationForm extends Equatable {
  final UniqueId id;
  final String otpCode; // passed in header
  final PhoneNumber phoneNumber;

  const M4eAuthOTPVerificationForm._(this.id, this.otpCode, this.phoneNumber);

  factory M4eAuthOTPVerificationForm({
    @required UniqueId id,
    @required String otpCode,
    @required PhoneNumber phoneNumber,
  }) {
    assert(id != null, 'M4eAuthPhoneNumberForm [id] should not be null');
    assert(
        otpCode != null, 'M4eAuthPhoneNumberForm [otpCode] should not be null');
    assert(phoneNumber != null,
        'M4eAuthPhoneNumberForm [phoneNumber] should not be null');

    return M4eAuthOTPVerificationForm._(id, otpCode, phoneNumber);
  }
 
  Map<String, dynamic> toJson() {
    return {
      'id': id.value.toString(),
      'phone': phoneNumber.toJson(),
    };
  }

  @override
  List<Object> get props => [id, otpCode, phoneNumber];

  @override
  String toString() =>
      'M4eAuthOTPVerificationForm(id: ${id.value.toString()} otpCode: $otpCode, phoneNumber: $phoneNumber)';
}
