import 'package:equatable/equatable.dart';
import 'package:flutter/foundation.dart';

import '../../core/core.dart';
import '../../models/shared/phone_number_model.dart';

class M4eAuthPhoneNumberForm extends Equatable {
  final UniqueId id;
  final PhoneNumber phoneNumber;

  const M4eAuthPhoneNumberForm._(this.id, this.phoneNumber);

  factory M4eAuthPhoneNumberForm(
      {@required UniqueId id, @required PhoneNumber phoneNumber}) {
    assert(id != null, 'M4eAuthPhoneNumberForm [id] should not be null');
    assert(phoneNumber != null,
        'M4eAuthPhoneNumberForm [phoneNumber] should not be null');

    return M4eAuthPhoneNumberForm._(id, phoneNumber);
  }

  Map<String, dynamic> toJson() {
    return {
      'id': id.value.toString(),
      'phone': phoneNumber.toJson(),
    };
  }

  @override
  List<Object> get props => [id, phoneNumber];

  @override
  String toString() =>
      'M4eAuthPhoneNumberForm(id: ${id.value.toString()}, phoneNumber: ${phoneNumber.number}, country: ${phoneNumber.country})';
}
