import 'package:equatable/equatable.dart';
import 'package:flutter/foundation.dart';

class Amount extends Equatable {
  final double value;
  final String currency;

  const Amount._(this.value, this.currency);

  factory Amount({@required double value, @required String currency}) {
    assert(value != null, 'Amount [value] should not be null');
    assert(currency != null, 'Amount [currency] should not be null');
    return Amount._(value, currency);
  }

  factory Amount.fromJson(Map<String, dynamic> json) {
    return Amount(
      value: json['value'],
      currency: json['unit'],
    );
  }

  Map<String, dynamic> toMap() {
    return {
      'value': this.value,
      'unit': this.currency,
    };
  }

  @override
  List<Object> get props => [
        value,
        currency,
      ];

  @override
  String toString() => 'Amount(value: $value, currency: $currency)';
}
