import 'package:equatable/equatable.dart';
import 'package:flutter/foundation.dart';

import '../core/core.dart';

class AuthToken extends Equatable {
  final UniqueId id;
  final String token;

  const AuthToken._(this.id, this.token);

  factory AuthToken({@required UniqueId id, @required String token}) {
    assert(id != null, 'AuthToken [id] should not be null');
    assert(token != null, 'AuthToken [token] should not be null');
    return AuthToken._(id, token);
  }

  factory AuthToken.fromJson(Map<String, dynamic> json) {
    return AuthToken(
      id: UniqueId.fromUniqueString(json['id']),
      token: json['token'],
    );
  }

  Map<String, dynamic> toJson() {
    return {
      'id': this.id.value,
      'token': this.token,
    };
  }

  @override
  List<Object> get props => [id, token];

  @override
  String toString() => 'AuthToken(id: $id, token: $token)';
}
