import 'package:equatable/equatable.dart';
import 'package:flutter/foundation.dart';

class PhoneNumber extends Equatable {
  final String number;
  final String country;

  const PhoneNumber._(this.number, this.country);

  factory PhoneNumber({@required String number, @required String country}) {
    assert(country != null, 'PhoneNumber [country] should not be null');
    assert(number != null, 'PhoneNumber [number] should not be null');
    return PhoneNumber._(number, country);
  }

  factory PhoneNumber.fromJson(Map<String, dynamic> jsonMap) {
    return PhoneNumber(
      country: jsonMap['country'],
      number: jsonMap['number'],
    );
  }

  Map<String, dynamic> toJson() {
    return {
      'country': this.country,
      'number': this.number,
    };
  }

  @override
  List<Object> get props => [number, country];

  @override
  String toString() => 'PhoneNumber(number: $number, country: $country)';
}
