class TransactionType {
  final String _transactionType;

  const TransactionType._internal(this._transactionType);

  static const cashIn = TransactionType._internal('CASH_IN');
  static const cashOut = TransactionType._internal('CASH_OUT');

  static TransactionType parse(String type) {
    return TransactionType._internal(type);
  }
  
  @override
  String toString() => _transactionType;

  bool operator ==(o) =>
      (o is TransactionType) && o._transactionType == this._transactionType;

  @override
  int get hashCode => _transactionType.hashCode;
}
