import 'package:equatable/equatable.dart';
import 'package:flutter/foundation.dart';

import '../core/core.dart';
import '../models/models.dart';

class TransactionResult extends Equatable {
  final UniqueId from;
  final UniqueId to;
  final Amount amount;
  final DateTime at;
  final String txType;

  const TransactionResult({
    @required this.from,
    @required this.to,
    @required this.amount,
    @required this.at,
    @required this.txType,
  });

  factory TransactionResult.fromJson(Map<String, dynamic> json) {
    return TransactionResult(
      from: UniqueId.fromUniqueString(json['flow']['from']),
      to: UniqueId.fromUniqueString(json['flow']['to']),
      amount: Amount.fromJson(json['flow']['amount']),
      at: DateTimeConverter.fromTimestampSinceEpoch(json['flow']['at']),
      txType: json['txType'],
    );
  }

  @override
  List<Object> get props => [from, to, amount, at];

  @override
  String toString() {
    return 'TransactionResult(from: $from, to: $to, amount: $amount, at: $at, txType: $txType)';
  }
}
