import 'package:flutter_test/flutter_test.dart';
import 'package:m4e_sdk/src/core/core.dart';
import 'package:m4e_sdk/src/data/services/services.dart';
import 'package:m4e_sdk/src/m4e_sdk_initialize.dart';

void main() {
  setUpAll(() {
    initializeM4eSDK(
      config:
          SDKConfig.development(appId: 'b834b997-64ed-4a19-b8fa-de14d6b005b6'),
    );
  });

  group('M4eAuth Test | ', () {
    test('Constructing Auth should find correct dependencies', () {
      final _auth = M4eAuth();
      expect(_auth != null, true);
    });
  });

  group('M4eTransaction Test | ', () {
    test('Constructing transaction should find correct dependencies', () {
      final _transaction = M4eTransaction();
      expect(_transaction != null, true);
    });
  });

  group('M4eWallet Test | ', () {
    test('Constructing Wallet should find correct dependencies', () {
      final _wallet = M4eWallet();
      expect(_wallet != null, true);
    });
  });
}
